/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1998
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *   Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: peks-random.c,v 1.5 1999/01/09 18:36:13 jordan Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * PEKS - private exponent key stuff for Diffie Hellman and El Gamal
 */


#include "common-stuff.h"
#include "crandom.h"
#include "peks-baseXX.h"
#include "baseXX.h"

void
getMpzRandomNumber (ROP, bits)
     mpz_t *ROP ;
     unsigned bits;
{
  unsigned  n = (bits + 7) / 8 ;
  char *t, *s = ALLOCA (n) ;

  setRandomBytes (s, n);
  t = bin2base64 (s, n) ;
  DEALLOCA (s) ;
  base64toMpz (ROP, t) ;
  XFREE (t) ;
}

